package dev.shadowsoffire.apotheosis.mixin;

import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import dev.shadowsoffire.placebo.json.JsonUtil;
import net.minecraftforge.common.crafting.conditions.ICondition;
import dev.shadowsoffire.placebo.Placebo;
import net.minecraft.world.level.storage.loot.LootTable;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import com.google.gson.JsonElement;
import net.minecraft.resources.ResourceLocation;
import com.google.gson.Gson;
import net.minecraftforge.common.ForgeHooks;
import org.spongepowered.asm.mixin.Mixin;

@Mixin({ ForgeHooks.class })
public class ForgeHooksMixin
{
    @Inject(at = { @At("HEAD") }, method = { "loadLootTable(Lcom/google/gson/Gson;Lnet/minecraft/resources/ResourceLocation;Lcom/google/gson/JsonElement;Z)Lnet/minecraft/world/level/storage/loot/LootTable;" }, cancellable = true, require = 1, remap = false)
    private static void apoth_lootTableConditions(final Gson gson, final ResourceLocation name, final JsonElement data, final boolean custom, final CallbackInfoReturnable<LootTable> cir) {
        if (!JsonUtil.checkConditions(data, name, "loot_table", Placebo.LOGGER, ICondition.IContext.EMPTY)) {
            cir.setReturnValue((Object)LootTable.f_79105_);
        }
    }
}
